-- MP5 Grenade Launcher
-- By z

-- Settings
parse("mp_wpndmg Flamethrower 0")
parse("mp_wpndmg Claw 0")

function Sound3(file,x,y,radius)
	for _, id in pairs(player(0,"table")) do
		if math.sqrt((x-player(id,"x"))^2 + (y-player(id,"y"))^2) < radius then
			parse("sv_sound2 "..id.." "..file)
		end
	end
end

function CalcDmg(health,armor,dmg)
	if armor >= 0 and armor <= 200 then
		armor = armor - dmg
		if armor < 0 then
			health = health + armor
			armor = 0
		end
	elseif armor == 201 then
		-- - 25% dmg
		health = health - math.floor((dmg/100)*25)
	elseif armor == 202 or armor == 204 then
		-- - 50% dmg
		health = health - math.floor((dmg/100)*50)
	elseif armor == 203 then
		-- - 75% dmg
		health = health - math.floor((dmg/100)*75)
	elseif armor == 205 then
		-- - 95% dmg
		health = health - math.floor((dmg/100)*95)
	elseif armor == 206 then
		health = health - dmg
	end
	return {h = health,a = armor}
end

function DistInto(fromx,fromy,tox,toy)
	return math.sqrt((fromx-tox)^2 + (fromy-toy)^2)
end

function array(m)
	local array = {}
	for i = 1, m do
		array[i] = 0
	end
	return array
end

addhook("use","_use")
function _use(id)
	local wpn = player(id,"weapon")
	if player(id,"exists") and player(id,"health")>0 and player(id,"team")>0 then
			if wpn == 20 and grenade_timer[id]==0 then
				if mp5_grenades[id]>0 then
					local rot = player(id,"rot")
					if rot < -90 then rot = rot + 360 end
					local angle = math.rad(math.abs( rot + 90 )) - math.pi
					local x = player(id,"x") + math.cos(angle) * 10
					local y = player(id,"y") + math.sin(angle) * 10
						grenade_timer[id]=1
						Grenade_Number = Grenade_Number + 1
						Grenade_Table[Grenade_Number] = {x = x,y = y,rot = angle,img = image(Grenade_img,x,y,1),imgrot = 0,target_x = cursor_x[id],target_y = cursor_y[id],pid = id,move = 1}
						mp5_grenades[id]=mp5_grenades[id]-1
						Sound3("CrazyBooy/glauncher"..math.random(1,2)..".wav",player(id,"x"),player(id,"y"),350)
						show_grenades(id)
				else
					Sound3("weapons/w_empty.wav",player(id,"x"),player(id,"y"),300)
				end
			end
		end
	if action == 2 then
		menu(id,"WEAPON MENU,Buy MP5|$1500,Buy MP5 Grenade x2|$"..Grenade_cost..",Hornet Launcher|$4000,Gluon|$10000")
	end
end

addhook("serveraction","_act")
function _act(id,action)
	if action == 2 then
		menu(id,"WEAPON MENU,Buy MP5|$1500,Buy MP5 Grenade x2|$"..Grenade_cost.."")
	end
end	

addhook("leave","_leave")
function _leave(id)
parse('hudtxt2 '..id..' 1 "" 0 0 ')
end

addhook("menu","_menu")
function _menu(id,title,buton)
	if title == "WEAPON MENU" then
		if buton == 1 then
			if (player(id,"money")>1499) then
				parse("equip "..id.." 20")
				parse("setweapon "..id.." 20")
				parse("setmoney "..id.." "..(player(id,"money")-1500))
			else
				msg2(id,"255000000You have insufficient funds!@C")
			end
		elseif buton == 2 then
			if (player(id,"money")>(Grenade_cost-1)) then
				if mp5_grenades[id]<10 then
					mp5_grenades[id]=mp5_grenades[id]+2
						parse("setmoney "..id.." "..(player(id,"money")-Grenade_cost))
						if mp5_grenades[id]==11 then
							mp5_grenades[id]=10
							show_grenades(id)
						end
						show_grenades(id)
				else
					msg2(id,"255000000You Cant Buy More Grenades!@C")
				end
			else
				msg2(id,"255000000You have insufficient funds!@C")
			end
		end
	end
end

addhook("select","_select")
function _select(id,type)
if type==20 then
show_grenades(id)
parse('speedmod '..id..' 0')
else
parse('hudtxt2 '..id..' 1 "" 0 0')
parse('speedmod '..id..' 0')
end
end

addhook("spawn","_spawn")
function _spawn(id)
parse('hudtxt2 '..id..' 1 "" 0 0')
end


addhook("drop","_drop")
function _drop(id,iid,type)
if type==20 then
parse('hudtxt2 '..id..' 1 "" 0 0')
end
end

-- Grenade Informations
Grenade_img = "gfx/weapons/mp5_grenade.bmp"
Grenade_cost = 500
Grenade_Explode_Size = 50
Grenade_Explode_Dmg = 100
No_Buy = 0
No_Walkover = 0

Grenade_Table = {}
-- End Of Informations

cursor_x=array(32)
cursor_y=array(32)
grenade_timer=array(32)
mp5_grenades=array(32)

addhook("second","_second")
function _second()
for _, id in ipairs(player(0,"table")) do
if player(id,"exists") and player(id,"health")>0 and player(id,"team")>0 then
if grenade_timer[id]>0 then
grenade_timer[id] = grenade_timer[id] - 1
end
end
end
end

timer(1,"requestdata","",0)

function requestdata()
	reqcld(0,2)
end

addhook("clientdata","_clientdata")
function _clientdata(id,mode,x,y)
	if mode == 2 then
		cursor_x[id] = x
		cursor_y[id] = y
	end
end

Grenade_Table[1] = {
	x = 0,
	y = 0,
	rot = 0,
	img = 0,
	imgrot = 0,
	target_x = 0,
	target_y = 0,
	pid = 0,
	move = 0
			}

Grenade_Number = 1

function show_grenades(id)
parse('hudtxt2 '..id..' 1 "Grenades: '..mp5_grenades[id]..'" 10 200')
end

addhook("minute","_minute")
function _minute()
	msg("000255000Half Life Weapons Script By (Apple) z!")
	msg("000255000Press F3 For WEAPON MENU!")
end

addhook("buy","_buy")
function _buy(id)
	if No_Buy == 1 then
		return 1
	end
end

addhook("walkover","_walkover")
function _walkover(id,iid,type)
if No_Walkover==1 then
	if (type>=61 and type<=68) or type==57 or type==58 then
			return 0
		end
	return 1
	end
end

addhook("always","_always")
function _always()
	for all = 1,#Grenade_Table do
		if Grenade_Table[all].move == 1 then
			local x = Grenade_Table[all].x + math.cos(Grenade_Table[all].rot) * 6
			local y = Grenade_Table[all].y + math.sin(Grenade_Table[all].rot) * 6
			Grenade_Table[all].imgrot=Grenade_Table[all].imgrot+10
			Grenade_Table[all].x=x
			Grenade_Table[all].y=y
			imagepos(Grenade_Table[all].img,x,y,Grenade_Table[all].imgrot)
			if math.floor(Grenade_Table[all].x/32)==math.floor(Grenade_Table[all].target_x/32) and math.floor(Grenade_Table[all].y/32)==math.floor(Grenade_Table[all].target_y/32) then
				parse("explosion "..x.." "..y.." "..Grenade_Explode_Size.." "..Grenade_Explode_Dmg.." "..Grenade_Table[all].pid)
				Grenade_Table[all].move=0
				freeimage(Grenade_Table[all].img)
			end
			if tile(math.floor(Grenade_Table[all].x/32),math.floor(Grenade_Table[all].y/32),"wall") then
				parse("explosion "..x.." "..y.." "..Grenade_Explode_Size.." "..Grenade_Explode_Dmg.." "..Grenade_Table[all].pid)
				Grenade_Table[all].move=0
				freeimage(Grenade_Table[all].img)
			end
			for _, id in pairs(player(0,"table")) do
				if player(id,"exists") and player(id,"health")>0 and id~=Grenade_Table[all].pid then
					if math.sqrt((Grenade_Table[all].x-player(id,"x"))^2 + (Grenade_Table[all].y-player(id,"y"))^2) < 25 then
						parse("explosion "..x.." "..y.." "..Grenade_Explode_Size.." "..Grenade_Explode_Dmg.." "..Grenade_Table[all].pid)
						Grenade_Table[all].move=0
						freeimage(Grenade_Table[all].img)
					end
				end
			end
		end
	end
end







